Index: /trunk/src/PSRFits.cc
===================================================================
--- /trunk/src/PSRFits.cc	(revision 1)
+++ /trunk/src/PSRFits.cc	(revision 1)
@@ -0,0 +1,439 @@
+#include "PSRFits.hh"
+#include <iostream>
+#include <string>
+#include "Utils.hh"
+#include "Block.hh"
+#include "Header.hh"
+
+#define USE_X true
+
+using namespace Block;
+using namespace Header;
+
+namespace FITS
+{
+  
+  void FITSError(std::string function, int status)
+  {
+    std::cerr << "FITSError <" << function << "> (status="<<status<<"): ";
+    fits_report_error(stderr, status);
+  }
+ //--------------------------------------------------------------------------
+
+  PSRFits::PSRFits()
+  {
+    this->newFile = true;
+    this->filestate = CLOSED;
+  }
+ //--------------------------------------------------------------------------
+
+  PSRFits::PSRFits(std::string name)
+  {
+    this->filestate = CLOSED;
+    this->openFile(name);
+  }
+ //--------------------------------------------------------------------------
+
+  PSRFits::~PSRFits()
+  {
+  }
+ //--------------------------------------------------------------------------
+
+  int PSRFits::openFile(std::string name)
+  {
+    int status = 0;
+    char *template_file = (char *)getPSRFITSdefn().c_str();
+    fits_create_template(&this->fptr, name.c_str(), template_file, &status);
+    if(status) FITSError("PSRFits::openFile",status);
+    else{
+      this->newFile = true;
+      this->filestate = OPEN;
+      this->fixPSRFITS();
+    }
+    return status;
+  }
+ //--------------------------------------------------------------------------
+  
+  int PSRFits::closeFile()
+  {
+    int status = 0;
+    if(this->filestate == OPEN){
+      fits_close_file(this->fptr, &status);
+      if(status) FITSError("PSRFits::closeFile",status);
+      this->filestate = CLOSED;
+    }
+    return status;
+  }
+ //--------------------------------------------------------------------------
+  
+  int PSRFits::gotoPHU()
+  {
+    int status = 0;
+    fits_movabs_hdu(this->fptr, 1, NULL, &status);    
+    if(status) FITSError("PSRFits::gotoPHU",status);
+    return status;
+  }
+ //--------------------------------------------------------------------------
+  
+  int PSRFits::gotoSubint()
+  {
+    int status = 0;
+    fits_movnam_hdu(this->fptr, ANY_HDU, "subint", 0, &status);
+    if(status) FITSError("PSRFits::gotoSubint",status);
+    return status;
+  }
+ //--------------------------------------------------------------------------
+  
+  template <typename T> int PSRFits::updateKeyword(std::string name, T value)
+  {
+    int status=0;
+    fits_update_key(this->fptr, TINT, name.c_str(), &value, NULL, &status);
+    if(status) FITSError("PSRFits::updateKeyword",status);
+    return status;
+  }
+  template <> int PSRFits::updateKeyword(std::string name, int value){
+    int status=0;
+    fits_update_key(this->fptr, TINT, (char *)name.c_str(), 
+		    &value, NULL, &status);
+    if(status) FITSError("PSRFits::updateKeyword",status);
+    return status;
+  }
+  template <> int PSRFits::updateKeyword(std::string name, float value){
+    int status=0;
+    fits_update_key(this->fptr, TFLOAT, (char *)name.c_str(),
+		    &value, NULL, &status);
+    if(status) FITSError("PSRFits::updateKeyword",status);
+    return status;
+  }
+  template <> int PSRFits::updateKeyword(std::string name, double value){
+    int status=0;
+    fits_update_key(this->fptr, TDOUBLE, (char *)name.c_str(), 
+		    &value, NULL, &status);
+    if(status) FITSError("PSRFits::updateKeyword",status);
+    return status;
+  }
+  template <> int PSRFits::updateKeyword(std::string name, std::string value){
+    int status=0;
+    fits_update_key(this->fptr, TSTRING, (char *)name.c_str(), 
+		    (char *)value.c_str(), NULL, &status);
+    if(status) FITSError("PSRFits::updateKeyword",status);
+    return status;
+  }
+  template <> int PSRFits::updateKeyword(std::string name, char *value){
+    int status=0;
+    fits_update_key(this->fptr, TSTRING, (char *)name.c_str(), 
+		    value, NULL, &status);
+    if(status) FITSError("PSRFits::updateKeyword",status);
+    return status;
+  }
+ //--------------------------------------------------------------------------
+
+  int PSRFits::getColnum(char *name){
+    int status=0,colnum=0;
+    fits_get_colnum(this->fptr, CASEINSEN, name, &colnum, &status);
+    if(status) FITSError("getColnum", status);
+    return colnum;
+  }
+  
+  long PSRFits::getNumRows(){
+    int status=0;
+    long nrows=0;
+    fits_get_num_rows(this->fptr, &nrows, &status);
+    if(status) FITSError("getNumRows", status);
+    return nrows;
+  }
+  
+  template <class T> int PSRFits::writeColumnValue(char *name, T value)
+  {
+    int status=0;
+    int colnum = this->getColnum(name);
+    long nrows = this->getNumRows();
+    fits_write_col(this->fptr, TINT, colnum, nrows, 1, 1, &value, &status);
+    if(status) FITSError("PSRFits::writeColumnValue", status);
+    return status;
+  }
+  template <> int PSRFits::writeColumnValue(char *name, long value)
+  {
+    int status=0;
+    int colnum = this->getColnum(name);
+    long nrows = this->getNumRows();
+    fits_write_col(this->fptr, TLONG, colnum, nrows, 1, 1, &value, &status);
+    if(status) FITSError("PSRFits::writeColumnValue", status);
+    return status;
+  }
+  template <> int PSRFits::writeColumnValue(char *name, float value)
+  {
+    int status=0;
+    int colnum = this->getColnum(name);
+    long nrows = this->getNumRows();
+    fits_write_col(this->fptr, TFLOAT, colnum, nrows, 1, 1, &value, &status);
+    if(status) FITSError("PSRFits::writeColumnValue", status);
+    return status;
+  }
+  template <> int PSRFits::writeColumnValue(char *name, double value)
+  {
+    int status=0;
+    int colnum = this->getColnum(name);
+    long nrows = this->getNumRows();
+    fits_write_col(this->fptr, TDOUBLE, colnum, nrows, 1, 1, &value, &status);
+    if(status) FITSError("PSRFits::writeColumnValue", status);
+    return status;
+  }
+ //--------------------------------------------------------------------------
+
+  int PSRFits::startNewRow()
+  {
+    int nrows = this->getNumRows();
+    int status = 0;
+    fits_insert_rows(this->fptr, nrows, 1, &status);
+    this->writeColumnValue("ISUBINT", nrows+1);
+    if(status) FITSError("PSRFits::startNewRow", status);
+    return status;
+  }
+ //--------------------------------------------------------------------------
+
+  void PSRFits::writePHU(DataBlock &block)
+  {
+    this->gotoPHU();
+
+    char *todaysdate;
+    int timeref,status=0;
+    fits_get_system_time(todaysdate, &timeref, &status);
+    
+    int ct=1;
+    this->updateKeyword("DATE", todaysdate);
+//     this->updateKeyword("PROJID", block.getSurveyName());
+    this->updateKeyword("TELESCOP", block.getKeyword<std::string>(TELID));
+//     this->updateKeyword("ANT_X", block.Survey().getAntX());          
+//     this->updateKeyword("ANT_Y", block.Survey().getAntY());        
+//     this->updateKeyword("ANT_Z", block.Survey().getAntZ());        
+    //CHECK -- find out these correct values
+//     this->updateKeyword("FRONTEND" **survey-dependent** );
+//     this->updateKeyword("FD_POLN " **survey-dependent** );
+//     this->updateKeyword("FD_HAND " **survey-dependent** );
+//     this->updateKeyword("FD_SANG " **survey-dependent** );
+//     this->updateKeyword("FD_XYPH " **survey-dependent** );
+//     this->updateKeyword("BACKEND " **survey-dependent** );
+//     this->updateKeyword("BECONFIG" **survey-dependent** );
+//     this->updateKeyword("BE_PHASE" **survey-dependent** );
+//     this->updateKeyword("BE_DCC  " **survey-dependent** );
+//     this->updateKeyword("TCYCLE  " **survey-dependent** );
+    this->updateKeyword("NRCVR", block.getKeyword<int>(NFILTER));          
+    this->updateKeyword("OBS_MODE", PHU_kw_obs_mode);
+    this->updateKeyword("SRC_NAME", block.getKeyword<std::string>(PSRNAME));
+    //  CHECK -- NEED TO DECIDE ON RA/DEC OR GL/GB
+    this->updateKeyword("COORD_MD", PHU_kw_coord_md);
+    this->updateKeyword("STT_CRD1", block.getKeyword<std::string>(RA_STRT));
+    this->updateKeyword("STT_CRD2", block.getKeyword<std::string>(DEC_STRT));
+
+//     this->updateKeyword("TRK_MODE",    **irrelevant**       );
+    this->updateKeyword("STP_CRD1", block.getKeyword<std::string>(RA_STRT));
+    this->updateKeyword("STP_CRD2", block.getKeyword<std::string>(DEC_STRT));
+
+//     this->updateKeyword("SCANLEN", block.Survey().getScanLen());
+    this->updateKeyword("FD_MODE", block.getKeyword<std::string>(FDCNTRL));
+    this->updateKeyword("FA_REQ", block.getKeyword<float>(FEED_ANGLE));       
+//     this->updateKeyword("CAL_MODE" **no information**   );
+//     this->updateKeyword("CAL_FREQ" **no information**   );
+    this->updateKeyword("CAL_DCYC", block.getKeyword<std::string>(CAL_CYCLE));
+    //     this->updateKeyword("CAL_PHS ", **no information**   );
+    // CHECK -- STT_DATE NEEDS TO BE PUT INTO A STANDARD FORMAT.
+    std::string stt_date = block.getKeyword<std::string>(DATE);
+    if(stt_date[0] == '0') stt_date = "20" + stt_date;
+    else                   stt_date = "19" + stt_date;
+    this->updateKeyword("STT_DATE", stt_date);
+    this->updateKeyword("STT_TIME", block.getKeyword<std::string>(UT_STRT));
+    this->updateKeyword("STT_IMJD", block.getKeyword<int>(MJD));
+//     this->updateKeyword("STT_SMJD" **calculatable**     );
+//     this->updateKeyword("STT_OFFS" **unclear**          );
+    this->updateKeyword("STT_LST ", 
+			dmsToDec(block.getKeyword<std::string>(LST_STRT)) );
+  }
+ //--------------------------------------------------------------------------
+
+  void PSRFits::writeSubint(DataBlock &block)
+  {
+    this->gotoSubint();
+    int ct = 1;
+
+    this->updateKeyword("NCH_FILE", block.getKeyword<int>(NCHAN));
+    this->updateKeyword("INT_TYPE", SUBINT_kw_int_type);
+    this->updateKeyword("INT_UNIT", SUBINT_kw_int_unit);
+    this->updateKeyword("NCH_STRT", SUBINT_kw_nch_strt);
+
+    float off_sub;
+    // CHECK -- OFF_SUB is the offset, from the start (taken to mean the 
+    // CHECK -- starting time listed in the PHU), of the centre of the 
+    // CHECK -- current subintegration.
+    // CHECK -- This will need to be calculated from the keywords UT_STRT
+    // CHECK -- and UT (being the UT at the *start* of the current block)
+
+
+    this->startNewRow(); 
+    // CHECK -- need some check of blk_cntr to make sure the number is 
+    // CHECK -- incrementing correctly?
+    this->writeColumnValue("TSUBINT",  block.getKeyword<float>(BLK_SEC));
+    this->writeColumnValue("OFFS_SUB", off_sub);
+    this->writeColumnValue("LST_SUB",  
+			   dmsToDec(block.getKeyword<std::string>(LST)) );
+    this->writeColumnValue("RA_SUB",   
+			   dmsToDec(block.getKeyword<std::string>(RA))*15. );
+    this->writeColumnValue("DEC_SUB",  
+			   dmsToDec(block.getKeyword<std::string>(DEC)) );
+    this->writeColumnValue("GLON_SUB", block.getKeyword<double>(GL));
+    this->writeColumnValue("GLAT_SUB", block.getKeyword<double>(GB));
+    this->writeColumnValue("FD_ANG",   block.getKeyword<float>(FEED_ANGLE));
+//     this->writeColumnValue("POS_ANG",  posang);
+    this->writeColumnValue("PAR_ANG",  block.getKeyword<float>(PANGLE));
+    this->writeColumnValue("TEL_AZ",   block.getKeyword<float>(TEL_AZ));
+    this->writeColumnValue("TEL_ZEN",  block.getKeyword<float>(TEL_ZEN));
+    
+    this->writeSupportArrays(block); //DAT_FREQ,DAT_WTS,DAT_OFFS,DAT_SCL
+
+    this->writeDataArray(block);
+   
+  }
+ //--------------------------------------------------------------------------
+
+  void PSRFits::writeSupportArrays(DataBlock &block)
+  {
+    int numChannels = block.getKeyword<int>(NCHAN);
+    float *dat_freq = new float[numChannels];
+    dat_freq[0] = block.getKeyword<float>(FREQ_CHAN1);
+    float deltaFreq = block.getKeyword<float>(CHANBW) / float(numChannels);
+    for(int i=1;i<numChannels;i++) dat_freq[i] = dat_freq[i-1] + deltaFreq;
+
+    float *dat_wts = new float[numChannels];
+    for(int i=0;i<numChannels;i++) dat_wts[i] = 1.;
+    float *dat_offs = new float[numChannels];
+    for(int i=0;i<numChannels;i++) dat_offs[i] = 0.;
+    float *dat_scl = new float[numChannels];
+    for(int i=0;i<numChannels;i++) dat_scl[i] = 1.;
+
+    int status = 0;
+    long nrows = this->getNumRows();
+
+    int colnum = this->getColnum("DAT_FREQ");
+    status=0;
+    fits_modify_vector_len (fptr, colnum, numChannels, &status);
+    if(status) FITSError("PSRFits::writeSupportArray", status);
+    status=0;
+    fits_write_col(this->fptr, TFLOAT, colnum, nrows, 1, 
+		   numChannels, dat_freq, &status);
+    if(status) FITSError("PSRFits::writeSupportArrays", status);
+
+    colnum = this->getColnum("DAT_WTS");
+    status=0;
+    fits_modify_vector_len (fptr, colnum, numChannels, &status);
+    if(status) FITSError("PSRFits::writeSupportArray", status);
+    status=0;
+    fits_write_col(this->fptr, TFLOAT, colnum, nrows, 1, 
+		   numChannels, dat_wts, &status);
+    if(status) FITSError("PSRFits::writeSupportArrays", status);
+
+    colnum = this->getColnum("DAT_OFFS");
+    status=0;
+    fits_modify_vector_len (fptr, colnum, numChannels, &status);
+    if(status) FITSError("PSRFits::writeSupportArray", status);
+    status=0;
+    fits_write_col(this->fptr, TFLOAT, colnum, nrows, 1, 
+		   numChannels, dat_offs, &status);
+    if(status) FITSError("PSRFits::writeSupportArrays", status);
+
+    colnum = this->getColnum("DAT_SCL");
+    status=0;
+    fits_modify_vector_len (fptr, colnum, numChannels, &status);
+    if(status) FITSError("PSRFits::writeSupportArray", status);
+    status=0;
+    fits_write_col(this->fptr, TFLOAT, colnum, nrows, 1, 
+		   numChannels, dat_scl, &status);
+    if(status) FITSError("PSRFits::writeSupportArrays", status);
+
+  }
+ //--------------------------------------------------------------------------
+
+  void PSRFits::writeDataArray(DataBlock &block)
+  {
+    long nrows = this->getNumRows();
+    int colnum = this->getColnum("DATA");
+    int status = 0;
+
+    int numChan = block.getKeyword<int>(NCHAN,0);
+    int numPol  = block.getKeyword<int>(NFILTER);
+    // CHECK -- HOW DOES NFILTER COMPARE TO NPOL???
+    int numBin  = block.getKeyword<int>(SAMP_GRP,0) * 
+      block.getKeyword<int>(GRP_BLK);
+
+    int dataPerByte = 8 / block.getKeyword<int>(NBITS,0);
+
+
+    int numData = numChan * numPol * numBin;
+    //CHECK -- IS THIS CONVERSION TO BYTES CORRECT?
+    int numBytes = numData / dataPerByte;   
+
+    unsigned char *data = (unsigned char *)block.getData();
+
+    //Fixing size of vector
+    if(this->newFile){
+      status=0;
+      if(USE_X) fits_modify_vector_len (this->fptr, colnum, numData, &status);
+      else      fits_modify_vector_len (this->fptr, colnum, numBytes, &status);
+      if(status) FITSError("PSRFits::writeDataArray", status);
+    }
+ 
+     long naxis=3,naxes[3];
+    // CHECK -- ORDER OF AXES: first axis is quickest-varying one, so this is 
+    // CHECK --  the channel axis. Next quickest is the pol axis (equivalent 
+    // CHECK --  to the filter? CHECK THIS). Slowest varying is the sample  
+    // CHECK --  axis (which has length numBin).
+    // CHECK -- IS THE CONVERSION TO BYTES CORRECT? We are dividing the channel
+    // CHECK --  axis, as this should be divisible by 8.
+    if(USE_X) naxes[0] = numChan; 
+    else      naxes[0] = numChan / dataPerByte; 
+    naxes[1] = numPol;
+    naxes[2] = numBin;
+    if(this->newFile){
+      status=0;
+      fits_write_tdim(this->fptr, colnum, naxis, naxes, &status);
+      if(status) FITSError("PSRFits::writeDataArray", status);
+    }
+
+    status=0;
+    fits_write_col_byt(fptr, colnum, nrows, 1, numBytes, data, &status);
+//     fits_write_col(this->fptr, TBYTE, colnum, nrows, 1, numBytes, data, &status);
+    if(status) FITSError("PSRFits::writeDataArray1", status);
+
+    if(USE_X && this->newFile) {
+      this->newFile = false;
+      status=0;
+      fits_delete_rows(this->fptr, nrows+1, 1, &status);
+      if(status) FITSError("PSRFits::writeDataArray", status);
+    }
+
+  
+
+  }
+ //--------------------------------------------------------------------------
+
+  void PSRFits::fixPSRFITS()
+  {
+    this->gotoSubint();
+    
+    int status=0;
+    char cval[9];
+    if(USE_X) strcpy(cval,"16X");
+    else      strcpy(cval,"2B");
+    fits_update_key(fptr, TSTRING, "TFORM19", cval, NULL, &status);
+    if(status) FITSError("PSRFits::fixPSRFITS", status);
+//     strcpy(cval,"deg");
+//     fits_update_key(fptr, TSTRING, "TUNIT6", cval, NULL, &status);
+//     if(status) FITSError("PSRFits::fixPSRFITS", status);
+//     fits_update_key(fptr, TSTRING, "TUNIT7", cval, NULL, &status);
+//     if(status) FITSError("PSRFits::fixPSRFITS", status);
+
+    this->gotoPHU();
+  }
+
+
+
+}
Index: /trunk/src/PSRFits.hh
===================================================================
--- /trunk/src/PSRFits.hh	(revision 1)
+++ /trunk/src/PSRFits.hh	(revision 1)
@@ -0,0 +1,60 @@
+#ifndef PSRFITS_HH_
+#define PSRFITS_HH_
+#include <fitsio.h>
+#include <string>
+#include "Block.hh"
+#include "Header.hh"
+
+using namespace Block;
+using namespace Header;
+
+namespace FITS
+{
+	
+  //	enum HDU = {PHU=1, HISTORY, DIG_STAT, DIG_CNTS, 
+
+  enum STATE { OPEN, CLOSED }; 
+	
+  void FITSError(std::string function, int status);
+  
+  const int SUBINT_kw_nch_strt = 0;
+  const std::string SUBINT_kw_int_type = "TIME";
+  const std::string SUBINT_kw_int_unit = "SEC";
+  const std::string PHU_kw_obs_mode = "SEARCH";
+  const std::string PHU_kw_coord_md = "J2000.0";
+  
+  class PSRFits
+  {
+  public:
+    PSRFits();
+    PSRFits(std::string name);
+    virtual ~PSRFits();
+    bool isNewFile(){return newFile;};
+    int openFile(std::string name);
+    void fixPSRFITS();
+    int closeFile();
+    STATE getFilestate(){return filestate;};
+    void setFilestate(STATE S){filestate=S;};
+    int gotoPHU();
+    int gotoSubint();
+    template <class T> int updateKeyword(std::string name, T value); 
+    template <class T> int writeColumnValue(char *name, T value);
+    int getColnum(char *name);
+    long getNumRows();
+    int startNewRow();
+    void writePHU(DataBlock &block);
+    void writeSubint(DataBlock &block);
+    void startNewColumn();
+    void writeColumnValue();
+    void writeSupportArrays(DataBlock &block);
+    void writeDataArray(DataBlock &block);
+    
+
+  private:
+    fitsfile *fptr;
+    bool newFile;
+    STATE filestate;
+  };
+
+}
+#endif /*PSRFITS_HH_*/
Index: /trunk/src/Utils.cc
===================================================================
--- /trunk/src/Utils.cc	(revision 1)
+++ /trunk/src/Utils.cc	(revision 1)
@@ -0,0 +1,39 @@
+#include "Utils.hh"
+#include <string>
+
+double dmsToDec(std::string input)
+{
+  /** 
+   *  double dmsToDec(string)
+   *   Converts a string in the format +12:23:34.45 to a decimal angle in 
+   *    degrees.
+   *   Assumes the angle given is in degrees, so if passing RA as the argument,
+   *   need to multiply by 15 to get the result in degrees rather than hours.
+   *   The sign of the angle is preserved, if present.
+   */
+
+  std::string dms = removeLeadingBlanks(input);
+
+  bool isNeg = false;
+  if(dms[0]=='-') isNeg = true;
+
+  for(int i=0;i<dms.size();i++) if(dms[i]==':') dms[i]=' ';
+
+  std::stringstream ss;
+  ss.str(dms);
+
+  std::string deg,min,sec;
+  getline(ss,deg,' ');
+  getline(ss,min,' ');
+  getline(ss,sec);
+  char *end;
+  double d = strtod(deg.c_str(),&end);
+  double m = strtod(min.c_str(),&end);
+  double s = strtod(sec.c_str(),&end);  
+
+  double dec = fabs(d) + m/60. + s/3600.;
+  if(isNeg) dec = dec * -1.;
+
+  return dec;
+
+}
Index: /trunk/src/Utils.hh
===================================================================
--- /trunk/src/Utils.hh	(revision 1)
+++ /trunk/src/Utils.hh	(revision 1)
@@ -0,0 +1,74 @@
+#ifndef UTILS_HH_
+#define UTILS_HH_
+#include <sstream>
+#include <string>
+#include <vector>
+
+inline std::string removeLeadingBlanks(std::string s)
+{
+  int i=0;
+  while(s[i]==' '){
+    i++;
+  }
+  std::string newstring;
+  for(int j=i;j<s.size();j++) newstring += s[j];
+  return newstring;
+}
+
+inline std::string charToBinary(char c)
+{
+  std::stringstream ss;
+  int num=c;
+  if (num<0) num+=256;
+  int factor = 128;
+  for(int i=0;i<8;i++){
+    ss << num/factor;
+    num -= num/factor * factor;
+    factor /= 2;
+  }
+  return ss.str();
+}
+
+inline std::string binaryToString(std::vector<bool> v)
+{
+  int size = v.size();
+  int nbytes = (size-1)/8 + 1;
+  std::string output;
+  for(int byte=0;byte<nbytes;byte++){
+    int c=0;
+    for(int bit=0;bit<8;bit++){
+      int pt = byte*8+bit;
+      if(v[pt]) c += int(pow(2,7-bit));
+    }
+    //    std::cerr << int(c) << std::endl;
+    output += char(c);
+  }
+  return output;
+}
+
+inline unsigned int * binaryToInt(std::vector<bool> v)
+{
+  int size = v.size();
+  int nbytes = (size-1)/8 + 1;
+  unsigned int *output = new unsigned int[nbytes];
+  for(int byte=0;byte<nbytes;byte++){
+    int c=0;
+    for(int bit=0;bit<8;bit++){
+      int pt = byte*8+bit;
+      if(v[pt]) c += (unsigned int)pow(2,7-bit);
+    }
+    //    std::cerr << c << std::endl;
+    output[byte] = c;
+  }
+  return output;
+}
+
+inline std::string getPSRFITSdefn()
+{
+  std::string defn = getenv("PSRFITSDEFN");
+  return defn;
+}
+
+double dmsToDec(std::string input);  // in Utils.cc
+
+#endif /*UTILS_HH_*/
Index: /trunk/src/tests/blocktest.cc
===================================================================
--- /trunk/src/tests/blocktest.cc	(revision 486)
+++ /trunk/src/tests/blocktest.cc	(revision 1)
@@ -2,6 +2,6 @@
 #include <fstream>
 #include <string>
-#include "../pvo-block.hh"
-#include "../pvo-header.hh"
+#include "../Block.hh"
+#include "../Header.hh"
 
 using namespace Header;
Index: /trunk/src/tests/headertest.cc
===================================================================
--- /trunk/src/tests/headertest.cc	(revision 486)
+++ /trunk/src/tests/headertest.cc	(revision 1)
@@ -1,4 +1,4 @@
 #include <iostream>
-#include "../pvo-header.hh"
+#include "../Header.hh"
 
 using namespace Header;
@@ -8,5 +8,5 @@
   try{
     std::cout <<"S70: ";
-    SurveySchema survey1(S70);
+    SurveySchema survey1("S70");
     std::cout << survey1.getStartPosition(FREQ_CHAN1) << std::endl;
     std::cout << survey1.readParameter<int>(hdrtest,TAPENR) << std::endl;
@@ -23,18 +23,14 @@
 		<< survey1.getFieldDimension(STATUS) << "\n";
     }
-    std::cout << "ANT_X = " << survey1.getAntX() <<"\n";
-    std::cout << "FD_POLN = " << survey1.getFd_poln() <<"\n";
-    std::cout << "FD_XYPH = " << survey1.getFd_xyph() <<"\n";
-    std::cout << "TCYCLE = " << survey1.getTcycle() << "\n";
 
     std::cout <<"PM : ";
-    SurveySchema survey2(PM);
+    SurveySchema survey2("PM");
     std::cout << survey2.getStartPosition(FREQ_CHAN1) << std::endl;
     std::cout << survey2.readParameter<int>(hdrtest,TAPENR) << std::endl;
     
-//     std::cout <<"BOB: ";
-//     SurveySchema survey3("BOB");
-//     std::cout << survey3.getStartPosition(FREQ_CHAN1) << std::endl;
-//     std::cout << survey3.readParameter<int>(hdrtest,TAPENR) << std::endl;
+    std::cout <<"BOB: ";
+    SurveySchema survey3("BOB");
+    std::cout << survey3.getStartPosition(FREQ_CHAN1) << std::endl;
+    std::cout << survey3.readParameter<int>(hdrtest,TAPENR) << std::endl;
  }
   catch(SurveySchema::xBadSurvey bad){
Index: /trunk/src/tests/psrfitstest.cc
===================================================================
--- /trunk/src/tests/psrfitstest.cc	(revision 486)
+++ /trunk/src/tests/psrfitstest.cc	(revision 1)
@@ -2,7 +2,7 @@
 #include <fstream>
 #include <string>
-#include "../pvo-block.hh"
-#include "../pvo-header.hh"
-#include "../pvo-FITS.hh"
+#include "../Block.hh"
+#include "../Header.hh"
+#include "../PSRFits.hh"
 
 using namespace Header;
Index: /trunk/src/tests/s70FullTest.cc
===================================================================
--- /trunk/src/tests/s70FullTest.cc	(revision 486)
+++ /trunk/src/tests/s70FullTest.cc	(revision 1)
@@ -4,7 +4,7 @@
 #include <iomanip>
 #include <string>
-#include "../pvo-block.hh"
-#include "../pvo-header.hh"
-#include "../pvo-FITS.hh"
+#include "../Block.hh"
+#include "../Header.hh"
+#include "../PSRFits.hh"
 
 using namespace Header;
@@ -12,14 +12,4 @@
 using namespace FITS;
 using std::string;
-
-ISMOVING moveStatus(std::string file)
-{
-  std::ifstream fin;
-  fin.open(file.c_str(), std::ios::binary);
-  DataBlock block(idSurvey(file));
-  block.readBlock(fin);
-  fin.close();
-  return ISMOVING(block.getKeyword<int>(MOVE));
-}
 
 std::string getFileName(int number)
@@ -33,5 +23,5 @@
 {
   std::string fname;
-  if(argc==1) fname = "data/s70_tape_test_S181_S18101.dat";
+  if(argc==1) fname = "../data/s70_tape_test_S181_S18101.dat";
   else if(argc==2) fname = argv[1];
   else{
@@ -43,31 +33,12 @@
 
   if(currentSurvey == PM){
-    std::cerr <<"\aOops! This is a PM survey!\n Good, but not for this program\nExiting...\n"; 
+    std::cerr <<"\aOops! This is a PM survey!\n Good, but not for this program\nExiting...\n";
   }
   if(currentSurvey != S70){
     if(currentSurvey!=PM)
-      std::cerr <<"\aOops! This isn't an S70 survey file!\nExiting...\n";
+      std::cerr <<"\aOops! This isn't an S70 survey!\nExiting...\n";
     return 1;
   }
   else std::cerr <<"Yes! This is an S70 survey file. Go ahead...\n";
-
-  ISMOVING status = moveStatus(fname);
-  if(status == NOTGRID){
-    std::cerr <<"\aOops! This is not a gridded observation -- and so not a survey\nExiting...";
-    return 1;
-  }
-  else if(status == SCANNING){
-    std::cerr <<"\aOops! This is a scanning observation -- how did that happen?\nExiting...";
-    return 1;
-  }
-  else if(status == MOVING)
-    std::cerr <<"OK... we are moving, but carry on in case we stop...\n";
-  else if(status == POINT)
-    std::cerr <<"Excellent... a pointed observation. Let's go!\n";
-  else{
-    std::cerr <<"\a\a\aOops! status is an unknown value (" 
-	      << status << ")\nExiting...\n";
-    return 1;
-  }
 
   std::ifstream fin;
@@ -76,19 +47,10 @@
   bool eof;
   DataBlock block(currentSurvey);
-  std::cerr << block.Survey().getAntX() << "\n";
-  SurveySchema testsurv(currentSurvey);
-  std::cerr << testsurv.getAntX() << "\n";
-  
   block.readBlock(fin);
   
-  std::string currentRA = block.getKeyword<std::string>(RA);
+  std::string currentRA = block.getKeyword<std::string>(RA_STRT);
 
   int filecount = 0;
-//   PSRFits fitsfile(getFileName(filecount++));
-  PSRFits fitsfile;
-  if(fitsfile.openFile(block)) {
-    std::cerr << "\aCannot open file.\nExiting...\n";
-    return 1;
-  }
+  PSRFits fitsfile(getFileName(filecount++));
   fitsfile.writePHU(block);
   
@@ -98,8 +60,5 @@
     if(block.getKeyword<int>(MOVE)!=MOVING) {
       std::cerr << "block " << blockcount++;
-      if(fitsfile.writeSubint(block)){
-	std::cerr << "Error. Exiting...\n";
-	return 1;
-      }
+      fitsfile.writeSubint(block);
       std::cerr << " done\n";
     }
@@ -107,10 +66,10 @@
 
     std::cerr << currentRA << " "
-	      << block.getKeyword<std::string>(RA) << " "
+	      << block.getKeyword<std::string>(RA_STRT) << " "
 	      << block.getKeyword<int>(MOVE) <<" ";
 
     if(!eof){
 
-      if((block.getKeyword<std::string>(RA) != currentRA)
+      if((block.getKeyword<std::string>(RA_STRT) != currentRA)
 	 || (block.getKeyword<int>(MOVE)==MOVING)){
 	std::cerr << "Changing FITS file -- " << filecount << "\n";
@@ -120,8 +79,7 @@
       if((fitsfile.getFilestate()==CLOSED)
 	 &&(block.getKeyword<int>(MOVE)==POINT)){
-// 	fitsfile.openFile(getFileName(filecount++));
-	fitsfile.openFile(block);
+	fitsfile.openFile(getFileName(filecount++));
 	fitsfile.writePHU(block);
-	currentRA = block.getKeyword<std::string>(RA);
+	currentRA = block.getKeyword<std::string>(RA_STRT);
       }
 
@@ -135,4 +93,4 @@
   fitsfile.closeFile();
   fin.close();
-  std::cerr << "\n";
+
 }
Index: /trunk/src/tests/testDataAccess.cc
===================================================================
--- /trunk/src/tests/testDataAccess.cc	(revision 486)
+++ /trunk/src/tests/testDataAccess.cc	(revision 1)
@@ -5,7 +5,7 @@
 #include <string>
 #include <vector>
-#include "../pvo-block.hh"
-#include "../pvo-header.hh"
-#include "../pvo-utils.hh"
+#include "../Block.hh"
+#include "../Header.hh"
+#include "../Utils.hh"
 
 using namespace Header;
Index: /trunk/src/tests/testFitsBinTable.cc
===================================================================
--- /trunk/src/tests/testFitsBinTable.cc	(revision 486)
+++ /trunk/src/tests/testFitsBinTable.cc	(revision 1)
@@ -2,5 +2,5 @@
 #include <sstream>
 #include <fitsio.h>
-#include "../pvo-utils.hh"
+#include "../Utils.hh"
 #include <vector>
 #include <string>
@@ -22,12 +22,10 @@
   char *template_file = (char *)getPSRFITSdefn().c_str();
   std::cerr << "opening with template...";
-    fits_create_template(&fptr, "!test.fits", getPSRFITSdefn().c_str(),&status);
+  //  fits_create_template(&fptr, "!test.fits", getPSRFITSdefn().c_str(),&status);
   //  fits_create_template(&fptr, "!test.fits", "simpletemplate.fits",&status);
 //   fits_create_template(&fptr,"!test.fits","combinedtemplate.fits",&status);
-    //fits_create_template(&fptr,"!test.fits","psrheaderSimple.txt",&status);
+  fits_create_template(&fptr,"!test.fits","psrheaderSimple.txt",&status);
   if(status) fits_report_error(stderr, status);
   std::cerr << "done.\n";
-
-  //----------------------------------------------------
 
   std::cerr << "moving to subint hdu...";
@@ -36,6 +34,4 @@
   if(status) fits_report_error(stderr, status);
   std::cerr << "done.\n";
-
-  //----------------------------------------------------
 
   int nch=16;
@@ -53,6 +49,4 @@
   std::cerr << "done.\n";
   
-  //----------------------------------------------------
-
   std::cerr << "fixing format...";
   std::stringstream ss;
@@ -75,6 +69,4 @@
   std::cerr << "done.\n";
 
-  //----------------------------------------------------
-
   std::cerr << "moving to primary hdu...";
   status = 0;
@@ -88,6 +80,4 @@
   std::cerr << "done.\n";
 
-  //----------------------------------------------------
-
   long nrows;
   std::cerr << "getting number of rows...";
@@ -97,5 +87,4 @@
   std::cerr << "num rows=" << nrows << std::endl;
   status=0;
-  std::cerr << "done.\n";
 
   // Add info in the TSUBINT column in the current row
@@ -110,6 +99,4 @@
 //   std::cerr << "done.\n";
   
-  //----------------------------------------------------
-
   std::cerr << "adding data array...";
   std::vector<bool> bin(nch*nbin*npol,false);
@@ -141,15 +128,10 @@
   /* */
   
-  //----------------------------------------------------
-
   std::cerr << "fixing size of vector...";
   status=0;
-  fits_modify_vector_len (fptr, colnum, nch*npol*nbin/8, &status);
-  //  fits_modify_vector_len (fptr, colnum, nch*npol*nbin, &status);
+//   fits_modify_vector_len (fptr, colnum, nch*npol*nbin/8, &status);
+  fits_modify_vector_len (fptr, colnum, nch*npol*nbin, &status);
   if(status) fits_report_error(stderr, status);
   std::cerr << "done.\n";
-
-  //----------------------------------------------------
-
   std::cerr << "fixing dimensions...";
   long naxis=3,naxes[3];
@@ -161,6 +143,4 @@
   if(status) fits_report_error(stderr, status);
   std::cerr << "done.\n";
-
-  //----------------------------------------------------
 
   std::cerr << "writing data...";
@@ -174,6 +154,4 @@
   std::cerr << "done.\n";
   /* */
-  //----------------------------------------------------
-
   std::cerr << "closing...";
   status = 0;
